/*
 This file is part of the digitalSTROM ds485-core library.

 Copyright (C) 2010 digitalSTROM.org, Schlieren, Switzerland

 digitalSTROM ds485-core library is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation version 2
 of the License.

 digitalSTROM ds485-core library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with digitalSTROM ds485-core library; if not, write to the Free Software
 Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef _dsid_h
#define _dsid_h

#if defined(__GNUC__)
#include <stdio.h>
#include <string.h>
#include <stdint.h>
#include <sys/types.h>
#include <unistd.h>
#include <sys/time.h> 
#elif defined(__MSVC__)
#endif

/**
 * 96-Bit dSID
 */
typedef struct dsid {
    unsigned char id[12];
} dsid_t;

#define IsBroadcastId(id) \
    (memcmp("\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff", &(id), sizeof(dsid_t)) == 0)

#define IsEqualId(id1, id2) \
    (memcmp(&(id1), &(id2), sizeof(dsid_t)) == 0)

#define SetBroadcastId(id) \
    memcpy(&(id), "\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff", sizeof(dsid_t))

#define SetNullId(id) \
    memcpy(&(id), "\0\0\0\0\0\0\0\0\0\0\0\0", sizeof(dsid_t))

#define IsNullId(id) \
    (memcmp("\0\0\0\0\0\0\0\0\0\0\0\0", &(id), sizeof(dsid_t)) == 0)

#if defined(__linux__)
# define BSP_MS_PER_TICKS 10
#elif defined(__APPLE__)
# define BSP_MS_PER_TICKS 10
#elif defined(__CYGWIN__)
# define BSP_MS_PER_TICKS 10
#endif

#endif
